Galería
=======

![Galeria](https://aztlan.fciencias.unam.mx/gitlab/canek/galeria/-/raw/main/static/galeria.png)

**Galería** (Spanish for *gallery*) is a
[Django](https://www.djangoproject.com/) webapp to provide a simple online photo
gallery.

The album structure in Galería es by design simple (or simplistic) and fixed:
top albums are years, which have month subalbums, which have events subalbums,
which have photographs. Although not mandatory, the idea is that each event time
range (the period of time between the first and last photographs in the event)
do not overlap.

Almost all the information in Galería is extracted from the photograph's
 metadata; it is expected that each one will have the following tags defined:

* `Exif.Photo.DateTimeOriginal`
* `Exif.Image.TimeZoneOffset`
* `Exif.Image.Orientation`
* `Iptc.Application2.Caption`
* `Xmp.dc.subject`
* `Exif.Image.ImageDescription`
* `Exif.GPSInfo.GPSLatitude`
* `Exif.GPSInfo.GPSLongitude`
* `Exif.GPSInfo.GPSLatitudeRef`
* `Exif.GPSInfo.GPSLongitudeRef`

The `Exif.Photo.DateTimeOriginal` and `Exif.Image.TimeZoneOffset` tags are used
to set a tiemstamp, which is the basis for organizing the photographs for the
photograph; without the timezone offset Galería will assume either the server
timezone or a timezone offset of zero. Galería will use the localized dates of
the photographs to decide its year and month albums.

The `Exif.Image.Orientation` is used to rotate the photographs if necessary,
particularly for thumbnails and previews.

The `Iptc.Application2.Caption` works as the title of the photograph; if
missing, the title will be the base name of the image file name, without
extension.

The `Xmp.dc.subject` works as the event album name for the photograph; its
normalization to ASCII and hypens will be used as the directory name for the
photograph; which will be inside a `01` - `12` directory for the month; which
will be inside a four digit directory for the year.

For example, a photograph with local timestamp of `2009-03-07 12:14:06`, with
`Xmp.dc.subject` tag set as *"Del Parque Güell al Maremagnum"*, will have the
following path in Galería:

```photos/2009/03/07/del-parque-guell-al-maremagnum```

Different scaled copies of the image are generated when its added to the
database; for example, the thumbnail for the image will have the following path
in Galería:

```thumbs/2009/03/07/del-parque-guell-al-maremagnum```

If the `Xmp.dc.subject` tag is missing, the photograph is asigned the album name
of "Saturday 7" (for example), and therefore its directory will be `saturday-7`.

The `Exif.Image.ImageDescription` tag is used for the comment or description of
the photograph.

The GPS information can be used to display a map with a marker for the
photograph; if there is no GPS information, no map is shown.

Galería never modifies the metadata in the photographs, it only reads it.

You can use the companion app
[GQPE](https://aztlan.fciencias.unam.mx/gitlab/canek/gqpe) to set the tags of
your photographs before uploading them to your Galería instance.
