const pageRegex = /page=(\d+)/;

var tpCache = new Array();
var dialogOpacity = 1.0;

function _getFirstPhotoAnchor() {
    previews = document.getElementsByClassName("preview");
    for (var i = 0; i < previews.length; i++) {
        var anchors = previews[i].getElementsByTagName('a');
        if (anchors.length == 0)
            continue;
        return anchors[0];
    }
    return null;
}

function _getLastPhotoAnchor() {
    previews = document.getElementsByClassName("preview");
    for (var i = previews.length - 1; i >= 0; i--) {
        var anchors = previews[i].getElementsByTagName('a');
        if (anchors.length == 0)
            continue;
        return anchors[0];
    }
    return null;
}

function changePage(path) {
    var select = document.getElementById("page-select");
    var page = select.options[select.selectedIndex].value;
    var newStr = 'page=' + page;
    url = path.replace(pageRegex, newStr);
    if (!path.includes('?')) {
        url = url + '?' + newStr;
    } else if (!path.includes('page=')) {
        url = url + '&' + newStr;
    }
    window.location.href = url;
}

function changeAlbum() {
    var select = document.getElementById("album-select");
    var path = select.options[select.selectedIndex].value;
    window.location.href = path;
}

function adminDropdown() {
    document.getElementById("admin-dropdown").classList.toggle("show");
}

window.onclick = function(event) {
    if (!event.target.matches('.drop-button')) {
        var dropdowns = document.getElementsByClassName("dropdown-content");
        var i;
        for (i = 0; i < dropdowns.length; i++) {
            var openDropdown = dropdowns[i];
            if (openDropdown.classList.contains('show')) {
                openDropdown.classList.remove('show');
            }
        }
    }
}

function clickElement(element) {
    var anchor = document.getElementById(element);
    if (anchor != null)
        anchor.click();
}

function _isKey(key, uc, lc) {
    return key == uc || key == lc;
}

document.addEventListener("keydown", function onEvent(event) {
    if (event.shiftKey && event.altKey && event.key == "ArrowLeft") {
        clickElement("prev-item")
    } else if (event.shiftKey && event.altKey && event.key == "ArrowRight") {
        clickElement("next-item");
    } else if (event.shiftKey && event.altKey && event.key == "ArrowUp") {
        clickElement("up-item");
    } else if (event.shiftKey && event.altKey && event.key == "PageUp") {
        clickElement("prev-page");
    } else if (event.shiftKey && event.altKey && event.key == "PageDown") {
        clickElement("next-page");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "C", "c")) {
        clickElement("menu-access");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "I", "i")) {
        clickElement("menu-info");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "P", "p")) {
        clickElement("menu-password");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "L", "l")) {
        clickElement("menu-download-covers");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "U", "u")) {
        clickElement("menu-upload");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "A", "a")) {
        clickElement("menu-api");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "D", "d")) {
        clickElement("menu-delete");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "H", "h")) {
        clickElement("menu-set-cover");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "R", "r")) {
        clickElement("menu-reset-covers");
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "M", "m")) {
        clickElement("menu-map");
    } else if (event.key == "Escape") {
        var overlay = document.getElementById("dialog-overlay");
        if (overlay.style.display == 'block' && overlay.style.opacity >= 1.0)
            dialogCancel();
    } else if (event.shiftKey && event.altKey && event.key == "Home") {
        var anchor = _getFirstPhotoAnchor();
        if (anchor != null)
            anchor.focus()
    } else if (event.shiftKey && event.altKey && event.key == "End") {
        var anchor = _getLastPhotoAnchor();
        if (anchor != null)
            anchor.focus()
    } else if (event.ctrlKey && event.altKey && _isKey(event.key, "S", "s")) {
        var search = document.getElementById("s");
        if (search != null)
            search.focus()
    }
});

function fadeOutDialog(deadline) {
    dialogOpacity = dialogOpacity - 0.1;
    var overlay = document.getElementById("dialog-overlay");
    overlay.style.opacity = dialogOpacity;
    if (dialogOpacity > 0.0)
        setTimeout(function() { requestIdleCallback(fadeOutDialog); }, 1);
    else
        _closeDialog();
}

function fadeInDialog(deadline) {
    dialogOpacity = dialogOpacity + 0.1;
    var overlay = document.getElementById("dialog-overlay");
    overlay.style.opacity = dialogOpacity;
    if (dialogOpacity < 1.0)
        setTimeout(function() { requestIdleCallback(fadeInDialog); }, 1);
}

function _hideDialog() {
    var frame = document.getElementById("frame");
    var overlay = document.getElementById("dialog-overlay");
    var dialogUrl = document.getElementById("dialog-url");
    var title = document.getElementById("dialog-title");
    var message = document.getElementById("dialog-message");
    var buttonOk = document.getElementById("dialog-ok");
    var buttonCancel = document.getElementById("dialog-cancel");
    overlay.style.display = 'none';
    title.textContent = '';
    message.textContent = '';
    buttonOk.textContent = '';
    buttonCancel.textContent = '';
    dialogUrl.value = '';
    overlay.style.opacity = 1.0;
}

function _closeDialog() {
    var dialogUrl = document.getElementById("dialog-url").value;
    _hideDialog();
    if (dialogUrl != '')
        window.location = dialogUrl;
}

function dialogOk() {
    dialogOpacity = 1.0;
    fadeOutDialog(null);
}

function dialogCancel() {
    var dialogUrl = document.getElementById("dialog-url");
    dialogUrl.value = '';
    dialogOpacity = 1.0;
    fadeOutDialog(null);
}

function askUser(title, message, doAction, cancelAction, link) {
    var frame = document.getElementById("frame");
    var overlay = document.getElementById("dialog-overlay");
    var dialogUrl = document.getElementById("dialog-url");
    var dTitle = document.getElementById("dialog-title");
    var dMessage = document.getElementById("dialog-message");
    var buttonOk = document.getElementById("dialog-ok");
    var buttonCancel = document.getElementById("dialog-cancel");
    dTitle.textContent = title
    dMessage.textContent = message;
    buttonOk.textContent = doAction;
    buttonCancel.textContent = cancelAction;
    dialogUrl.value = link;
    dialogOpacity = 0.0;
    overlay.style.opacity = 0.0;
    overlay.style.display = 'block';
    buttonCancel.focus()
    fadeInDialog(null);
}
